using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Library
{
	public class fSearch : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListView lvwResults;
		private System.Windows.Forms.ColumnHeader colTitle;
		private System.Windows.Forms.ColumnHeader colTopic;
		private System.Windows.Forms.ColumnHeader colLang;
		private System.ComponentModel.IContainer components;
		public fSearch()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			this.lvwResults = new System.Windows.Forms.ListView();
			this.colTitle = new System.Windows.Forms.ColumnHeader();
			this.colTopic = new System.Windows.Forms.ColumnHeader();
			this.colLang = new System.Windows.Forms.ColumnHeader();
			this.SuspendLayout();
			// 
			// lvwResults
			// 
			this.lvwResults.Activation = System.Windows.Forms.ItemActivation.TwoClick;
			this.lvwResults.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lvwResults.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.colTitle,
																						 this.colTopic,
																						 this.colLang});
			this.lvwResults.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lvwResults.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lvwResults.ForeColor = System.Drawing.Color.Blue;
			this.lvwResults.FullRowSelect = true;
			this.lvwResults.GridLines = true;
			this.lvwResults.HideSelection = false;
			this.lvwResults.MultiSelect = false;
			this.lvwResults.Name = "lvwResults";
			this.lvwResults.Size = new System.Drawing.Size(320, 174);
			this.lvwResults.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.lvwResults.TabIndex = 0;
			this.lvwResults.View = System.Windows.Forms.View.Details;
			this.lvwResults.ItemActivate += new System.EventHandler(this.lvwResults_ItemActivate);
			this.lvwResults.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.lvwResults_ColumnClick);
			this.lvwResults.SelectedIndexChanged += new System.EventHandler(this.lvwResults_SelectedIndexChanged);
			// 
			// colTitle
			// 
			this.colTitle.Text = "Title";
			this.colTitle.Width = 159;
			// 
			// colTopic
			// 
			this.colTopic.Text = "Topic";
			// 
			// colLang
			// 
			this.colLang.Text = "Language";
			this.colLang.Width = 100;
			// 
			// fSearch
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(320, 174);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lvwResults});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.Name = "fSearch";
			this.ShowInTaskbar = false;
			this.Text = "Search Results";
			this.Load += new System.EventHandler(this.fSearch_Load);
			this.VisibleChanged += new System.EventHandler(this.fSearch_VisibleChanged);
			this.ResumeLayout(false);

		}
		#endregion

		private void fSearch_VisibleChanged(object sender, System.EventArgs e)
		{
			if(this.Visible == true)
			{
				foreach(CodeSample a in modMain.PreviousSearch)
				{
					if(a.Title != "Removed")
					{
						ListViewItem tempItem = new ListViewItem(a.Title, modMain.Topics[modMain.GetTopic(a.Topic)].Icon);
						tempItem.SubItems.Add(modMain.Topics[modMain.GetTopic(a.Topic)].Name);
						tempItem.SubItems.Add(a.Language);
						foreach(Language t in modMain.Languages)
							if(t.Name == a.Language)
								tempItem.ForeColor = t.Colour;
						this.lvwResults.Items.Add(tempItem);
					}
				}
				if(this.lvwResults.Items.Count == 0)
					this.Text = this.Text + ": No Items Found";
				else
					this.Text = this.Text + ": " + this.lvwResults.Items.Count + " Items Found";
			}
		}

		private void fSearch_Load(object sender, System.EventArgs e)
		{
			this.lvwResults.SmallImageList = modMain.iconList;
		}

		private void lvwResults_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			
		}

		private void lvwResults_ItemActivate(object sender, System.EventArgs e)
		{
			try
			{
				modMain.SelectedCode = modMain.FindCodeSearch(this.lvwResults.SelectedItems[0].Text, this.lvwResults.SelectedItems[0].SubItems[1].Text);
				modMain.OpenCodeWindow();
			}
			catch
			{}
		}

		private void lvwResults_ColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e)
		{
			this.lvwResults.ListViewItemSorter = new ListViewItemComparer(e.Column);
		}
	}

	class ListViewItemComparer : IComparer
	{
		private int col;
		public ListViewItemComparer()
		{
			col = 0;
		}
		public ListViewItemComparer(int column)
		{
			col = column;
		}
		public int Compare(object x, object y)
		{
			return String.Compare(((ListViewItem)x).SubItems[col].Text, ((ListViewItem)y).SubItems[col].Text);
		}
	}

}
